TextEditor.configure do
  config.default_flavor ||= :nano

  log.file ||= nil
  log.level = Logger::INFO
  log.options = []

  tab.soft = true
  tab.width = 2

  flavor :nano do
    mode :insert do
      bind :ctrl_c, :quit

      bind :up, :cursor_up
      bind :down, :cursor_down
      bind :left, :cursor_left_with_wrap
      bind :right, :cursor_right_with_wrap

      bind :ctrl_p, :cursor_up
      bind :ctrl_n, :cursor_down
      bind :ctrl_b, :cursor_left_with_wrap
      bind :ctrl_f, :cursor_right_with_wrap

      bind :ctrl_a, :cursor_start
      bind :ctrl_e, :cursor_end

      bind :ctrl_space, :forward_word

      bind :backspace, :backspace
      bind :ctrl_h, :backspace

      bind :ctrl_o, :write_file

      bind :enter, :insert_line
      bind :tab, :insert_tab

      bind(/^[[:print:]]$/, :insert_char)
    end
  end

  flavor :vim do
    mode :normal do
      bind :ctrl_c, :quit

      bind :k, :cursor_up
      bind :j, :cursor_down
      bind :h, :cursor_left
      bind :l, :cursor_right

      bind :^, :cursor_start_without_whitespace
      bind :"0", :cursor_start
      bind :"$", :cursor_end

      bind :w, :forward_word

      bind :S, :replace_line

      bind :a, :cursor_right_and_insert
      bind :A, :cursor_end_and_insert

      bind :o, :append_line_and_insert
      bind :O, :prepend_line_and_insert

      bind :i, :change_mode, :insert
    end

    mode :insert do
      bind :ctrl_c, :change_mode, :normal
      bind :escape, :change_mode, :normal

      bind :up, :cursor_up
      bind :down, :cursor_down
      bind :left, :cursor_left
      bind :right, :cursor_right

      bind :backspace, :backspace
      bind :ctrl_h, :backspace

      bind :ctrl_j, :insert_line
      bind :enter, :insert_line

      bind :tab, :insert_tab

      bind(/^[[:print:]]$/, :insert_char)
    end
  end
end
