module CoreExt
  module Hash
    refine ::Hash do
      # Returns a new hash with each key replaced
      # with the return value of the specified block.
      def transform_keys
        reduce({}) do |hash, (key, value)|
          key = yield(key)
          hash.update(key => value)
        end
      end
    end
  end
end
