class TextEditor
  class Command
    extend Forwardable
    include Component

    def_delegators :editor, :window
    def_delegators :window, :buffer, :cursor, :state
    def_delegators :cursor, :line, :column

    def self.call(editor, *args, &block)
      new(editor).run(*args, &block)
    end

    def content
      buffer.line(line)
    end

    def run(*)
      raise NotImplementedError
    end

    def scan
      @scan ||= StringScanner.new(content)
    end
  end
end
