class TextEditor
  class Command
    class Backspace < Command
      def run(*)
        if column.zero? && line.nonzero?
          content = buffer.line(line.pred)
          new_column = content.size
          content << buffer.line(line)

          new_buffer = buffer.replace_line(line.pred, content)
          new_buffer = new_buffer.delete_line(line)

          new_cursor = cursor.move(line.pred, new_column)
        elsif column.nonzero?
          new_buffer = buffer.delete_char(line, column.pred)
          new_cursor = cursor.left
        else
          new_buffer = buffer
          new_cursor = cursor
        end

        window.update(new_buffer, new_cursor)
      end
    end
  end
end
