class TextEditor
  class Command
    class CursorDown < Command
      def run(*)
        lines = buffer.size.pred
        return if line == lines

        columns = buffer.line(line.next).size
        new_cursor = cursor.down.clamp(lines, columns)
        window.update(buffer, new_cursor)
      end
    end
  end
end
