class TextEditor
  class Command
    class CursorLeftWithWrap < Command
      def run(*)
        if column.zero? && line.nonzero?
          column = buffer.line(line.pred).size
          new_cursor = cursor.move(line.pred, column)
        else
          new_cursor = cursor.left
        end

        window.update(buffer, new_cursor)
      end
    end
  end
end
