class TextEditor
  class Command
    class CursorRightWithWrap < Command
      def run(*)
        columns = content.size
        lines = buffer.size.pred

        new_cursor =
          if column == columns && line != lines
            cursor.move(line.next, 0)
          else
            cursor.right.clamp(lines, columns)
          end

        window.update(buffer, new_cursor)
      end
    end
  end
end
