class TextEditor
  class Command
    class ForwardWord < Command
      def run(*)
        lines = buffer.size.pred
        index = content.index(/\W/, column.next)
        index ||= column

        new_cursor = cursor.move(line, index.next)
        new_cursor = new_cursor.clamp(lines, content.size)

        window.update(buffer, new_cursor)
      end
    end
  end
end
