class TextEditor
  class Command
    class InsertLine < Command
      def run(*)
        current = content[0...column]
        newline = content[column..-1]

        new_buffer = buffer.replace_line(line, current)
        new_buffer = new_buffer.insert_line(line.next, newline)

        new_cursor = cursor.move(line.next, 0)
        window.update(new_buffer, new_cursor)
      end
    end
  end
end
