class TextEditor
  class Configuration
    class Mode
      attr_reader :name

      def initialize(name, &block)
        @name = name.to_sym
        instance_eval(&block) if block
      end

      def bind(key, command = nil, *args, &block)
        keybindings[key] = [command || block, args]
      end

      def keybindings
        @keybindings ||= {}
      end

      def resolve(key)
        keybindings.each do |keybinding, command|
          return command if keybinding === key
        end

        nil
      end
    end
  end
end
