class TextEditor
  class Configuration
    class OperatingSystem
      attr_reader :version

      def initialize(version)
        @version = version
      end

      def type
        case version
        when /cygwin/      then :Cygwin
        when /bsd|linux/   then :Linux
        when /darwin|mac/  then :Mac
        when /mingw|mswin/ then :Windows
        else :Unknown
        end
      end
    end
  end
end
