class TextEditor
  class Configuration
    class Resolver
      include Component

      FILE = ".text_editor.rb".freeze

      def files
        @files ||= configs.select(&:exist?)
      end

      private

      def configs
        directories.map do |directory|
          directory.join(FILE)
        end
      end

      def directories
        [editor.root, etc, home, *tree].uniq
      end

      def etc
        Pathname.new("/etc")
      end

      def home
        Pathname.new(ENV["HOME"])
      end

      def pwd
        Pathname.new(Dir.pwd)
      end

      def tree
        [pwd].tap do |tree|
          until [home, tree.first].include?(tree.first.dirname)
            tree.unshift(tree.first.dirname)
          end
        end
      end
    end
  end
end
