class TextEditor
  class Terminal
    include Component
    include Curses

    public :beep, :clear, :lines

    def columns
      cols
    end

    def keys
      self.class.constants.sort.grep(/^KEY/).reduce({}) do |hash, constant|
        value = self.class.const_get(constant)
        hash.update(constant => value)
      end
    end

    def input
      getch
    end

    def render
      noecho              # hide typed characters
      nonl                # disable newline translation
      stdscr.keypad(true) # enable arrow keys
      raw                 # enable all other keys
      init_screen
      start_color
      yield
    ensure
      clear
      close_screen
    end

    def window(lines, columns, y, x)
      stdscr.subwin(lines, columns, y, x)
    end
  end
end
